// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMEUIMM_ABOUT_H
#define _LIBGNOMEUIMM_ABOUT_H


#include <glibmm.h>

// -*- C++ -*-

/* $Id: about.hg,v 1.9 2002/06/16 16:14:58 murrayc Exp $ */

/* about.h
 * 
 * Copyright (C) 1998 EMC Capital Management Inc.
 * Developed by Havoc Pennington <hp@pobox.com>
 *
 * Copyright (C) 1999 The Gtk-- Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/arrayhandle.h>
#include <gtkmm/dialog.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GnomeAbout GnomeAbout;
typedef struct _GnomeAboutClass GnomeAboutClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace UI
{ class About_Class; } // namespace UI

} // namespace Gnome
namespace Gnome
{

namespace UI
{

/** Small window for displaying brief info about the application.
 *
 * For normal applications, an item to the help menu should be added to pop up
 * the box. The box is supposed to contain a short description of the
 * application together with the version string, copyright info, and a list of
 * authors, documenters and translators.
 */

class About : public Gtk::Dialog
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef About CppObjectType;
  typedef About_Class CppClassType;
  typedef GnomeAbout BaseObjectType;
  typedef GnomeAboutClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~About();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class About_Class;
  static CppClassType about_class_;

  // noncopyable
  About(const About&);
  About& operator=(const About&);

protected:
  explicit About(const Glib::ConstructParams& construct_params);
  explicit About(GnomeAbout* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GnomeAbout*       gobj()       { return reinterpret_cast<GnomeAbout*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GnomeAbout* gobj() const { return reinterpret_cast<GnomeAbout*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

  
public:
  /** Create an about box with the supplied information.
   * \param name is the name of the application.
   * \param version is the package version and is usually defined as VERSION if you use autoconf.
   * \param copyright is the copyright notice, like <code>"Copyright (c) 1913 Albert Einstein"</code>.
   * \param authors is a container with names of the authors of the application.
   * \param documenters is a container with names of the documenters of the application.
   * \param comments is the short description.
   * \param translator_credits which always should be empty or
   *        the string <code>"translator_credits"</code>.
   *
   * If the application is being translated, the translator credits string
   * should simply be "translator_credits" to allow the translators to
   * translate this string into a list of names of themselves. To avoid getting
   * the string "translator_credits" with untranslated runs of the program, test for
   * whether the string is actually changed. For instance:
   *
   * \code
   *   // note to translators: please fill in your names and email addresses
   *   Glib::ustring translators = _("translator_credits");
   *   if (translators == "translator_credits")
   *     translators = "";
   *
   *   // ...
   * \endcode
   *
   * The comment before the definition of the <code>translator</code> string
   * will survive into translator land.
   *
   * When the user presses the OK button, the box will hide itself. So one way
   * of implementing the about feature is to create the box once and store it
   * somewhere for the lifetime of the main window, and then simply call show()
   * and raise() on it when the about menu item is selected.
   * 
   */
  About(const Glib::ustring& name,
        const Glib::ustring& version,
        const Glib::ustring& copyright,
        const Glib::ArrayHandle<Glib::ustring>& authors,
        const Glib::ArrayHandle<Glib::ustring>& documenters,
        const Glib::ustring& comments = Glib::ustring(),
        const Glib::ustring& translator_credits = Glib::ustring());

  /** Create an about box with logo.
   * Contains an extra parameter which is a logo to display in the about box.
   */
  About(const Glib::ustring& name,
        const Glib::ustring& version,
        const Glib::ustring& copyright,
        const Glib::ArrayHandle<Glib::ustring>& authors,
        const Glib::ArrayHandle<Glib::ustring>& documenters,
        const Glib::ustring& comments,
        const Glib::ustring& translator_credits,
        const Glib::RefPtr<Gdk::Pixbuf>& logo);

  /** The name of the application.
   */
  #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Glib::ustring> property_name() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_name() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  /** Application version.
   */
  #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Glib::ustring> property_version() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_version() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  /** Copyright notice.
   */
  #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Glib::ustring> property_copyright() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_copyright() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  /** Short description.
   */
  #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Glib::ustring> property_comments() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_comments() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  //TODO: _WRAP_PROPERTY("authors", GParamValueArray)
  //TODO: _WRAP_PROPERTY("documenters", GParamValueArray)

  /** Translator credits string; should be empty or "translator_credits".
   */
  #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Glib::ustring> property_translator_credits() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_translator_credits() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


};

} /* namespace UI */
} /* namespace Gnome */


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gnome::UI::About
   */
  Gnome::UI::About* wrap(GnomeAbout* object, bool take_copy = false);
} //namespace Glib


#endif /* _LIBGNOMEUIMM_ABOUT_H */

